#include <eikenv.h>
#include <eikapp.h>
#include <eikappui.h>
#include <stdio.h>

#include <eikapp.h>
#include <e32base.h>
#ifdef S60
#else
#include <eikstart.h>

#define UIQ3
#include <qikselectfolderdlg.h>
#endif
#include <sdlapp.h>

class CDoomLegacyApp: public CSDLApp {
public:
	CDoomLegacyApp();
   	~CDoomLegacyApp();
	
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 	 * @return TInt, resource id
   	*/
	TInt ViewResourceId();
	
	TUid AppDllUid() const;

	CApaDocument*		CreateDocumentL();

	TBuf8<256> iWADDirectory;
};


CApaApplication* NewApplication() {
	// Return pointer to newly created CQMApp
	return new CDoomLegacyApp;
}
#ifdef UIQ3
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}
#endif

extern "C" void logit(const char* aString)
{
#ifdef __WINS__
	FILE* f = fopen("c:\\DoomLegacy.txt","a+b");

#else
	FILE* f = fopen("e:\\DoomLegacy.txt","a+b");
#endif
	if(f != NULL)
	{
		fprintf(f,aString);
		fprintf(f, "\r\n");
		fclose(f);
	}
}

_LIT8(KCWadDir,"c:\\media files\\other\\wad\\");
_LIT8(KDWadDir,"d:\\wad\\");
_LIT8(KEWadDir,"e:\\wad\\");
#include <bautils.h>
#include <stdlib.h>
CApaDocument*		CDoomLegacyApp::CreateDocumentL()
{
	CApaDocument*	doc = CSDLApp::CreateDocumentL();

	return doc;
}

CDoomLegacyApp::CDoomLegacyApp() {
}

CDoomLegacyApp::~CDoomLegacyApp() {
}
#ifdef UIQ3

#include <DoomLegacy.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CDoomLegacyApp::ViewResourceId() {
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif

extern "C" char* WADDataFolder()
{
#ifdef S60
	return "e:\\wad";
#else
#ifdef UIQ3
	if(static_cast<CDoomLegacyApp*>(CEikonEnv::Static()->EikAppUi()->Application())->iWADDirectory.Length() == 0)
	{
		TFileName filename;
		CQikSelectFolderDlg::RunDlgLD(filename, NULL);

		if(filename.Length() > 0)
		{
			static_cast<CDoomLegacyApp*>(CEikonEnv::Static()->EikAppUi()->Application())->iWADDirectory.Copy(filename);
		}
		else
		{
			static_cast<CDoomLegacyApp*>(CEikonEnv::Static()->EikAppUi()->Application())->iWADDirectory.Copy(KCWadDir());
		}						
	}
#else
	// Check for directory WAD on different paths
	TFileName waddir;
	waddir.Copy(KCWadDir());
	iWADDirectory = KEWadDir();

	if( BaflUtils::FolderExists(CEikonEnv::Static()->FsSession(), waddir))
	{
		iWADDirectory = KCWadDir();
	}
	else
	{
		waddir.Copy(KDWadDir());
		if( BaflUtils::FolderExists(CEikonEnv::Static()->FsSession(), waddir))
		{
			iWADDirectory = KDWadDir();
		}
		else
		{
			waddir.Copy(KEWadDir());
			if( BaflUtils::FolderExists(CEikonEnv::Static()->FsSession(), waddir))
			{
				iWADDirectory = KEWadDir();
			}
		}
	}
#endif
	return  (char*) static_cast<CDoomLegacyApp*>(CEikonEnv::Static()->EikAppUi()->Application())->iWADDirectory.PtrZ();
#endif

}

/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CDoomLegacyApp::AppDllUid() const {
	return TUid::Uid(0xF0009BB5);
}

/////////////////////////////////////////////////////////////////////////////////////////////////



//#ifdef LIBC
/*
FUNCTION
	<<bcopy>>---copy memory regions

ANSI_SYNOPSIS
	#include <string.h>
	void bcopy(const char *<[in]>, char  *<[out]>, size_t <[n]>);

TRAD_SYNOPSIS
	void bcopy(<[in]>, <[out]>, <[n]>
	char *<[in]>;
	char *<[out]>;
	size_t <[n]>;

DESCRIPTION
	This function copies <[n]> bytes from the memory region
	pointed to by <[in]> to the memory region pointed to by
	<[out]>.

	This function is implemented in term of <<memmove>>.

PORTABILITY
<<bcopy>> requires no supporting OS subroutines.

QUICKREF
	bcopy - pure
*/

#include <string.h>

extern "C" void bcopy(const char *b1,char* b2,size_t length)
{
  memmove (b2,  b1, length);
}

//#endif
